addpath(fullfile(pwd,'libs'));

% load ground truth pose estimates
ground_truth = load('ground_truth.mat');
seq_length = size(ground_truth.T,2);

% load object vertices
obj_scale = 1; 
obj_file = '../models/Clown_800/Clown_800.obj';
vertex_positions = ReadOBJ_MEX(obj_file,obj_scale);

% simulate some noisy estimated pose trace
randn('seed',1);
estimated = ground_truth;
estimated.T = estimated.T + 5.*randn(size(estimated.T));

% evaluate error (max distance of corresponding vertices)
resetThres = 10;
errors = zeros(seq_length,1);
for frame = 1:seq_length
  errors(frame) = maxdisterr(vertex_positions,ground_truth.R(:,frame),ground_truth.T(:,frame),estimated.R(:,frame),estimated.T(:,frame));
end

success = sum(errors<resetThres);
percentage_success = 100 .* (success ./ seq_length);
