#include <cstdio>
#include <cstring>
#include <math.h>
#include "mex.h"

#include "OBJModel.h"

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
  
  // Check for proper number of arguments

  if (nrhs != 2) {
    mexErrMsgTxt("MEXCPP requires two arguments.");
  } else if (nlhs > 1) {
    mexErrMsgTxt("MEXCPP requires at most one output argument.");
  }

  // Get the parameters

  // function [positions,normals] = ReadOBJ_MEX(fileName,scale)

  char *fileName = mxArrayToString(prhs[0]);
  float scale = mxGetScalar(prhs[1]);
  
  OBJModel objModel(fileName,scale);
  
  int nPositions = objModel.getNPositions();
  
  // Allocate space for output
  plhs[0] = mxCreateNumericMatrix(3,nPositions,mxSINGLE_CLASS,mxREAL);
  float *positions = (float *)mxGetPr(plhs[0]);
  
  // Copy objdata
  memcpy(positions,objModel.getPositions(),objModel.getNPositions()*3*sizeof(float));
  
  return;
}
